%define kde_version 3.0.5a

%define sourcedir stable/%{kde_version}/distribution/tar/generic/source
%define pkg kdemultimedia
%define DATE 20020327
%define is_release 1
%define beta %{nil}
%define rel 0.73.0

%define buildbrahms 0

%define libtool 1

Version: %{kde_version}
Name: kdemultimedia
Prefix: /usr
Icon: kde-icon.xpm
Summary: Multimedia applications for the K Desktop Environment (KDE).
Epoch: 6
License: GPL
Group: Applications/Multimedia
BuildRoot: %{_tmppath}/%{name}-buildroot

%if %{is_release}
%if "%{beta}" != ""
Release: 0.%{beta}.%{rel}
Source: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{version}%{beta}.tar.bz2
%else
Release: %{rel}
Source: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{version}%{beta}.tar.bz2
%endif
%else
Release: 0.cvs%{DATE}.%{rel}
Source: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{DATE}.tar.bz2
%endif

%if %buildbrahms
Source1: http://brahms.sourceforge.net/download/brahms-%{DATE}.tar.bz2
%endif

Source900: gccver.c

Patch1: kdemultimedia-2.2-redhat.patch
Patch2: kdemultimedia-2.1-glibc-2.2.2.patch
Patch3: brahms-20020107-kdemultimedia.patch
Patch4: kdemultimedia-3.0.4-debug.patch

Obsoletes: aktion

ExcludeArch: alpha

Prereq: /sbin/ldconfig

BuildRequires: qt-devel
BuildRequires: zlib-devel
BuildRequires: XFree86-devel
BuildRequires: kdelibs-devel >= 3.0.3
BuildRequires: kdebase-devel >= 3.0.3
BuildRequires: libjpeg-devel
BuildRequires: gcc-c++
BuildRequires: glibc-devel
BuildRequires: perl
BuildRequires: sh-utils

%description
The K Desktop Environment (KDE) is a GUI desktop for the X Window
System. The kdemultimedia package contains multimedia applications for
KDE, including: AKtion, a front end for the XAnim video player; kmidi,
a midi-to-wav player/converter; kmix, a mixer; and kscd, an audio CD
player.

%package arts
Summary: Additional functionality for the aRts sound system
Group: Applications/Multimedia
Obsoletes: kdemultimedia
Requires: %{name}-libs = %{epoch}:%{version}-%{release}

%description arts
Additional functionality for the aRts sound system.
Among other things, this adds MIDI support, some synthesizer functionality
and artsbuilder, a frontend for connecting aRts modules to generate
synthesizers.

%package devel
Summary: Development files for aRts plugins
Group: Development/Libraries
Requires: kdemultimedia-arts = %{epoch}:%{version}-%{release}
Requires: noatun = %{epoch}:%{version}-%{release}

%description devel
Development files for aRts and noatun plugins.
Install kdemultimedia-devel if you wish to develop or compile any
applications using aRtsbuilder, aRtsmidi, aRtskde, aRts modules or
noatun plugins.

%package -n kaboodle
Summary: A KDE media player
Group: Applications/Multimedia
Obsoletes: kdemultimedia

%description -n kaboodle
A KDE media player. Kaboodle supports playback of Ogg, MP3 (including streaming
MP3), MP2, WAV and MOD audio files as well as MPEG video files.

%package -n noatun
Summary: A KDE media player
Group: Applications/Multimedia
Obsoletes: kdemultimedia

%description -n noatun
A KDE media player. Noatun supports playback of Ogg, MP3 (including streaming
MP3), MP2, WAV and MOD audio files as well as MPEG video files.

%package kfile
Summary: KFile support for audio files
Group: Applications/Multimedia
Obsoletes: kdemultimedia

%description kfile
Installing kdemultimedia-kfile allows all KFile aware applications (most KDE
applications) to gather, display and edit information on Ogg, MP3, WAV and M3U
files.

%package -n kmid
Summary: A MIDI player (using the soundcard's sequencer functionality)
Group: Applications/Multimedia
Obsoletes: kdemultimedia

%description -n kmid
A MIDI player using the soundcard's sequencer functionality. kmid plays MIDI
files through an attached MIDI device or, if your hardware supports it, the
soundcard's sequencer functionality.

If you're looking for an application that plays MIDI files by converting
them to digital audio first (works on any soundcard and typically provides
better sound than a soundcard sequencer, but can't play to external MIDI
devices), try kmidi instead.

%package -n kmidi
Summary: A MIDI player (converting to digital audio)
Group: Applications/Multimedia
Obsoletes: kdemultimedia
Requires: timidity++

%description -n kmidi
A MIDI player. Kmidi works by converting MIDI files to digital audio and
sending them to your soundcard's DSP. It works on every soundcard supported
by Linux and typically gives better sound quality than using the soundcard's
builtin sequencer functionality (if any), but can't send output to external
MIDI devices.

If you're looking for an application that plays MIDI files to external
devices or your soundcard's builtin sequencer, try kmid instead.

%package -n kmix
Summary: KDE sound mixer applet
Group: Applications/Multimedia
Obsoletes: kdemultimedia

%description -n kmix
A sound mixer applet for KDE. kmix allows you to control the volumes of your
sound card from a KDE panel applet.

%package -n koncd
Summary: Frontend for mastering and burning CDs
Group: Applications/Archiving
Requires: cdrecord
Requires: mkisofs

%description -n koncd
KOnCD is a graphical frontend for mastering and burning CD-ROMs.

%package -n kscd
Summary: Audio-CD player for KDE
Group: Applications/Multimedia
Obsoletes: kdemultimedia

%description -n kscd
KSCD is an Audio-CD player for KDE.

%package libs
Summary: Libraries used by KDE multimedia applications
Group: System Environment/Libraries
Obsoletes: kdemultimedia

%description libs
Libraries used by KDE multimedia applications.
kdemultimedia-libs includes mpeglib.

%package -n brahms
Summary: MIDI sequencer and editor
Group: Applications/Multimedia

%description -n brahms
Brahms is a MIDI sequencer and editor.

%prep
rm -rf $RPM_BUILD_ROOT

%if %{is_release}
%setup -q -n %{name}-%{version}
%else
%setup -q -n %{name}
%endif

%patch1 -p1 -b .redhat
%patch2 -p1 -b .glibc222
%patch4 -p1 -b .debug

perl -pi -e "s,examples,,g" kmid/Make*
perl -pi -e "s/-fomit-frame-pointer//g" admin/acinclude.m4.in

# koncd isn't perfect, but it works. Build it.
rm -f koncd/configure.in.in

# remove aktion, we don't ship xanim (license problems)
rm -rf doc/aktion aktion

# Workaround for legacy auto* tools
%if %{libtool}
[ -x /usr/bin/autoconf-2.5? ] && ln -s /usr/bin/autoconf-2.5? autoconf
[ -x /usr/bin/autoheader-2.5? ] && ln -s /usr/bin/autoheader-2.5? autoheader
[ -x /usr/bin/aclocal-1.5 ] && ln -s /usr/bin/aclocal-1.5 aclocal
[ -x /usr/bin/automake-1.5 ] && ln -s /usr/bin/automake-1.5 automake
export PATH=`pwd`:$PATH
make -f admin/Makefile.common cvs
%endif

find . -name "*.moc" -exec rm -rf {} \;

%build
export KDEDIR=%{prefix}
unset QTDIR || : ; . /etc/profile.d/qt.sh
export PATH=%{prefix}/bin:$PATH
export FLAGS="$RPM_OPT_FLAGS -DNDEBUG"
export LANG=C

CFLAGS="$FLAGS" CXXFLAGS="$FLAGS -fno-check-new" \
./configure \
   --prefix=%{prefix} \
   --disable-motif \
   --with-motif-includes=none \
   --with-motif-libraries=none \
   --disable-debug \
   --without-debug \
   --without-alsa \
   --includedir=/usr/include/kde \
   --disable-xaw

# Do this once it's fixed: --enable-final \
gcc -o gccver %{SOURCE900}
if [ "0`./gccver`" -lt 3001 ]; then
   find . -name Makefile |xargs perl -pi -e "s,^CXXLD\s*=.*,\$& -release gcc`./gccver -v`,g"
fi

make %{?_smp_mflags}
make -C doc

%if %buildbrahms
# HACK: Build brahms after the rest was built... (the brahms build process requires
# kdemultimedia devel headers)...
# But it needs merged configure stuff...
tar xjf %{SOURCE1}
patch -p0 -b <%{PATCH3}
mv -f brahms/Brahms.kdelnk brahms/Brahms.desktop
mv -f brahms/brahms.kdelnk brahms/brahms.desktop
perl -pi -e "s,DQT_NO_ASCII_CAST,UQT_NO_ASCII_CAST,g" configure.in.in
make -f Makefile.cvs
CXXFLAGS="$FLAGS -fno-check-new" \
	./configure --prefix=%{prefix} \
	--disable-motif \
	--with-motif-includes=none \
	--with-motif-libraries=none \
	--disable-debug \
	--without-debug \
	--without-alsa \
	--includedir=/usr/include/kde
pushd brahms
make %{?_smp_mflags}
popd
%endif


%install
make install DESTDIR=$RPM_BUILD_ROOT
make -C doc DESTDIR=$RPM_BUILD_ROOT install

# KOnCD configuration...
mkdir -p $RPM_BUILD_ROOT%{_datadir}/config
cat >$RPM_BUILD_ROOT%{_datadir}/config/koncdrc <<EOF
[Program paths]
cdrdao_path=/usr/bin/cdrdao
cdrecord_path=/usr/bin/cdrecord
mkisofs_path=/usr/bin/mkisofs
readcd_path=/usr/bin/readcd
EOF

# Set symlinks for files we renamed because of compiler ABI issues
if [ "0`./gccver`" -lt 3001 ]; then
   REL="gcc`./gccver -v`"
   solink() {
      sover=$1
      somajor=`echo $sover |sed -e "s,\..*,,"`
      shift
      for i in $@; do
         if [ -e $RPM_BUILD_ROOT/%{_libdir}/lib${i}-${REL}.so ]; then
            ln -s lib${i}-${REL}.so $RPM_BUILD_ROOT/%{_libdir}/lib${i}.so.${sover}
            ln -s lib${i}-${REL}.so $RPM_BUILD_ROOT/%{_libdir}/lib${i}.so.${somajor}
         elif [ -e $RPM_BUILD_ROOT%{_libdir}/lib${i}-${REL}.so.? ]; then
            ln -s `basename $RPM_BUILD_ROOT%{_libdir}/lib${i}-${REL}.so.?` $RPM_BUILD_ROOT/%{_libdir}/lib${i}.so.${sover}
            ln -s `basename $RPM_BUILD_ROOT%{_libdir}/lib${i}-${REL}.so.?` $RPM_BUILD_ROOT/%{_libdir}/lib${i}.so.${somajor}
         fi
      done
   }
   solink 0.0.0 arts_splay artsbuilder artsgui artsgui_idl artsgui_kde artsmidi artsmidi_idl artsmodules
fi


pushd $RPM_BUILD_ROOT/%{_docdir}/HTML/en
for i in *; do
   rm -f $i/common
   ln -sf ../common $i
done
popd

%post arts -p /sbin/ldconfig
%postun arts -p /sbin/ldconfig

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%post -n noatun -p /sbin/ldconfig
%postun -n noatun -p /sbin/ldconfig

%post -n kscd -p /sbin/ldconfig
%postun -n kscd -p /sbin/ldconfig

%post -n kmid -p /sbin/ldconfig
%postun -n kmid -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files arts
%defattr(-,root,root)
%{_libdir}/mcop/Arts/*
%{_libdir}/mcop/arts*
%{_libdir}/mcop/*PlayObject.mcopclass
%{_libdir}/libarts*
%{_libdir}/libaudiofile*
%{_libdir}/mcop/audiofile*
%{_bindir}/arts*
%{_bindir}/midisend
%{_bindir}/mpeglibartsplay
%{_datadir}/apps/artsbuilder
%{_datadir}/apps/artscontrol
%{_datadir}/icons/*/*/*/arts*
%{_datadir}/applnk/Multimedia/arts*
%{_datadir}/mimelnk/*/x-arts*
%doc %{_docdir}/HTML/en/artsbuilder

%files -n kaboodle
%defattr(-,root,root)
%{_datadir}/icons/*/*/*/kaboodle.png
%{_datadir}/apps/kaboodle
%{_datadir}/applnk/Multimedia/kaboodle.desktop
%{_datadir}/services/kaboodle_component.desktop
%{_libdir}/libkaboodlepart*
%{_libdir}/kaboodle*.*
%{_bindir}/kaboodle

%files kfile
%defattr(-,root,root)
%{_libdir}/kde3/kfile_*
%{_datadir}/services/kfile_*

%files -n kmid
%defattr(-,root,root)
%{_datadir}/apps/kmid
%{_datadir}/icons/*/*/*/kmid.png
%{_datadir}/applnk/Multimedia/kmid.desktop
%{_datadir}/mimelnk/audio/x-karaoke.desktop
%{_datadir}/servicetypes/audiomidi.desktop
%{_libdir}/libkmidpart*
%{_bindir}/kmid
%doc %{_docdir}/HTML/en/kmid

%files -n kmidi
%defattr(-,root,root)
%{_datadir}/apps/kmidi
%{_datadir}/applnk/Multimedia/kmidi.desktop
%{_datadir}/applnk/Multimedia/timidity.desktop
%{_datadir}/icons/*/*/*/kmidi.png
%{_bindir}/kmidi
%{_bindir}/sf2cfg
%doc %{_docdir}/HTML/en/kmidi

%files -n kmix
%defattr(-,root,root)
%{_libdir}/kmix*
%{_libdir}/kde3/*kmix*
%{_datadir}/applnk/Multimedia/kmix.desktop
%{_datadir}/applnk/Settings/Sound/kmixcfg.desktop
%{_datadir}/icons/*/*/*/kmix.png
%{_datadir}/apps/kmix
%{_datadir}/apps/kicker/applets/kmixapplet.desktop
%{_datadir}/services/kmixctrl_restore.desktop
%{_bindir}/kmix*
%doc %{_docdir}/HTML/en/kmix

%files -n koncd
%defattr(-,root,root)
%{_datadir}/icons/*/*/*/koncd.png
%{_datadir}/apps/koncd
%{_datadir}/applnk/Multimedia/koncd.desktop
%{_bindir}/koncd
%{_datadir}/config/koncdrc
# %doc %{_docdir}/HTML/en/koncd

%files -n kscd
%defattr(-,root,root)
%{_datadir}/apps/kscd
%{_libdir}/libworkman*
%{_bindir}/kscd
%{_bindir}/workman2cddb.pl
%{_datadir}/icons/*/*/*/kscd.png
%{_datadir}/applnk/Multimedia/kscd.desktop
%{_datadir}/mimelnk/text/xmcd.desktop
%doc %{_docdir}/HTML/en/kscd

%files -n noatun
%defattr(-,root,root)
%{_datadir}/apps/noatun
%{_datadir}/apps/kconf_update/*
%{_datadir}/icons/*/*/*/noatun.png
%{_libdir}/mcop/Noatun
%{_libdir}/mcop/noatun*
%{_libdir}/mcop/ExtraStereo.mcopclass
%{_libdir}/mcop/VoiceRemoval.mcopclass
%{_libdir}/mcop/RawWriter.mcopclass
%{_libdir}/mcop/ExtraStereoGuiFactory.mcopclass
%{_libdir}/mcop/artseffects.mcop*
%{_libdir}/mcop/winskinvis.*
%{_libdir}/libdummy*
%{_libdir}/*noatun*
%{_libdir}/libartseffects*.*
%{_libdir}/kde3/noatun*
%{_libdir}/libwinskinvis*.*
%{_bindir}/noatun*
%{_datadir}/applnk/Multimedia/noatun.desktop
%doc %{_docdir}/HTML/en/noatun

%files libs
%defattr(-,root,root)
%{_libdir}/libmpeg*
%{_libdir}/libyaf*
%{_bindir}/yaf-*

%files devel
%defattr(-,root,root)
%{_includedir}/kde/arts/*
%{_includedir}/kde/noatun
%{_includedir}/kde/*.h
%{_includedir}/kde/mpeglib
%{_includedir}/mpeglib
%{_includedir}/kde/mpeglib_artsplug

%if %buildbrahms
%files -n brahms
%defattr(-,root,root)
%{_datadir}/apps/brahms
%{_datadir}/icons/*/*/*/brahms.png
%{_datadir}/applnk/Multimedia/brahms.desktop
%{_libdir}/*Brahms*
%{_libdir}/mcop/*Brahms*
%{_bindir}/brahms
%endif

%changelog
* Thu Dec 26 2002 Than Ngo <than@redhat.com> 3.0.5a-0.73.0
- 3.0.5a

* Sat Oct  5 2002 Than Ngo <than@redhat.com 3.0.3-0.7.1
- added a patch file to fix Konquror crahes when mp3/mpg file is clicked 

* Tue Aug 13 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.3-0.7
- 3.0.3

* Wed Apr 17 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-3
- Make sure we link to the just built libraries instead of libs in the
  build environment from older releases

* Tue Apr 16 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-2
- Update ABI
- Add cdrecord/mkisofs requirements for KOnCD (#63606)
- Tell koncd where to find cdrecord and mkisofs (#63604)

* Wed Mar 27 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-1
- 3.0.0 final

* Thu Mar 21 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-0.cvs20020321.1
- Adapt spec file to recent changes in base

* Thu Mar  7 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-0.cvs20020307.1
- Update
- Rename subpackages

* Fri Feb  1 2002 Tim Powers <timp@redhat.com>
- kdemultimedia-devel shouldn't obsolete itself
- temporarily ExcludeArch ia64

* Mon Aug  6 2001 Than Ngo <than@redhat.com> 2.2-1
- update to 2.2 release

* Fri Aug  3 2001 Than Ngo <than@redhat.com> 2.2-0.cvs20010803.1
- update
- fix bug #24132
- get rid of aktion

* Sun Jul 22 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.cvs20010722.1
- Update
- move devel files to a separate package
- Add BuildPrereqs (#44914)

* Wed Feb 21 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.1-respin

* Tue Feb 20 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.1

* Tue Feb 13 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Remove copyrighted midi files (#26431)
- Use a real file list rather than find/sed (#26565)
- Fix build with current glibc

* Thu Feb  1 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Replace absolute symlinks with relative ones (#24794)
- Don't use more than 2 CPUs at build time to shut up asok

* Mon Jan 22 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update

* Mon Jan  1 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update
- Don't optimize on sparc, compiler breakage

* Wed Dec 20 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update to CVS
- re-exclude ia64, the compiler can't handle this package

* Sun Oct 22 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0 final

* Tue Oct  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0

* Thu Aug 24 2000 Than Ngo <than@redhat.com>
- update kdemultimedia-1.93
- fix to rebuilt with gcc-2.96

* Mon Aug  7 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new version

* Wed Jul 19 2000 Than Ngo <than@redhat.de>
- fix to build against gcc-2.96-40 on sparc, alpha
- disable motif

* Thu Jul 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- SMPify
- don't hardcode QTDIR

* Tue Jul 11 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- use gcc 2.96
- new snapshot

* Sun Jul  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- use kernelcc
- new snapshot

* Fri Jun 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Obsoletes: aktion (it's included now)

* Wed Jun 21 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- ExcludeArch ia64 for now

* Sat Apr  8 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0 snapshot

* Tue Feb 29 2000 Preston Brown <pbrown@redhat.com>
- fix localkscd patch, broken since 6.1 (#9404).

* Fri Feb  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Remove (world!) write permissions to %{prefix}/share/apps/kscd/cddb/*
- fix description

* Thu Feb  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Change the kmix error message (Bug #9065)
- Fix kmidi behavior when trying to play an empty playlist (Bug #8843)
- Fix compilation with kernel 2.3.x headers

* Sat Jan  8 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- current version from KDE_1_1_BRANCH
- work around make install-strip breakage
- Rebuild for 6.2

* Sat Sep 25 1999 Preston Brown <pbrown@redhat.com>
- patched kscd to use local user directory for cddb entries

* Fri Sep 24 1999 Preston Brown <pbrown@redhat.com>
- mark doc files as such

* Thu Sep 09 1999 Preston Brown <pbrown@redhat.com>
- 1.1.2 release.

* Mon Jun 14 1999 Preston Brown <pbrown@redhat.com>
- snapshot, includes kde 1.1.1 + fixes

* Mon Apr 19 1999 Preston Brown <pbrown@redhat.com>
- last snapshot before release

* Tue Apr 13 1999 Preston Brown <pbrown@redhat.com>
- snapshot from today fixed kmid freeze issues

* Mon Apr 12 1999 Preston Brown <pbrown@redhat.com>
- latest stable snapshot

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Mon Feb 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to KDE 1.1 final.

* Sat Feb 06 1999 Preston Brown <pbrown@redhat.com>
- complies w/new RPM, newer libstdc++

* Wed Jan 06 1999 Preston Brown <pbrown@redhat.com>
- re-merged in updates from Duncan Haldane
